unit ClientDM;

interface

uses
  System.SysUtils, System.Classes, Data.DBXDataSnap, IndyPeerImpl,
  Data.DBXCommon, Data.DB, Data.SqlExpr, Datasnap.DSHTTPLayer, Data.FMTBcd,
  Datasnap.DBClient, Datasnap.Provider, Classes, DBXCommon, FMTBcd, DB,
  DBClient, Provider, SqlExpr;

type
  TDM = class(TDataModule)
    SQLConnection: TSQLConnection;
    DeptSqlServerMethod: TSqlServerMethod;
    EmpSqlServerMethod: TSqlServerMethod;
    DeptDataSetProvider: TDataSetProvider;
    EmpDataSetProvider: TDataSetProvider;
    DeptClientDataSet: TClientDataSet;
    EmpClientDataSet: TClientDataSet;
    DeptDataSource: TDataSource;
    EmpDataSource: TDataSource;
    procedure DeptDataSourceDataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    procedure Reopen;
    { Public declarations }
  end;

var
  DM: TDM;

implementation

{%CLASSGROUP 'System.Classes.TPersistent'}

{$R *.dfm}

procedure TDM.DeptDataSourceDataChange(Sender: TObject; Field: TField);
begin
  EmpClientDataSet.Close;
  EmpSqlServerMethod.ParamByName('DeptNo').AsInteger := DM.DeptClientDataSet.FieldByName('DEPTNO').AsInteger;
  EmpClientDataSet.Open;
end;

procedure TDM.Reopen;
begin
  EmpClientDataSet.Close;
  DeptClientDataSet.Close;
  DeptClientDataSet.Open;
  EmpSqlServerMethod.ParamByName('DeptNo').AsInteger := DM.DeptClientDataSet.FieldByName('DEPTNO').AsInteger;
  EmpClientDataSet.Open;
end;

end.
