//
// Created by the DataSnap proxy generator.
// 13.03.2013 17:47:21
//

unit ProxyGenerator;

interface

uses Data.DBXCommon, Data.DBXClient, Data.DBXDataSnap, Data.DBXJSON, Datasnap.DSProxy, System.Classes, System.SysUtils, Data.DB, Data.SqlExpr, Data.DBXDBReaders, Data.DBXJSONReflect;

type
  TServerMethodsClient = class(TDSAdminClient)
  private
    FGetDeptCommand: TDBXCommand;
    FGetEmpCommand: TDBXCommand;
    FCheckUserCommand: TDBXCommand;
    FDeptModifyCommand: TDBXCommand;
    FEmpModifyCommand: TDBXCommand;
  public
    constructor Create(ADBXConnection: TDBXConnection); overload;
    constructor Create(ADBXConnection: TDBXConnection; AInstanceOwner: Boolean); overload;
    destructor Destroy; override;
    function GetDept: TDataSet;
    function GetEmp(DeptNo: Integer): TDataSet;
    function CheckUser(username: string; passwd: string): Boolean;
    procedure DeptModify(DeptNo: Integer = -1; DName: string = ''; Loc: string = ''; op_type: Integer = 0);
    procedure EmpModify(Empno: Integer = -1; EName: string = ''; Job: string = ''; Mgr: Integer = 0; HireDate: TDateTime = 0; Sal: Double = 0; Comm: Double = 0; Deptno: Integer = -1; op_type: Integer = 0);
  end;

implementation

function TServerMethodsClient.GetDept: TDataSet;
begin
  if FGetDeptCommand = nil then
  begin
    FGetDeptCommand := FDBXConnection.CreateCommand;
    FGetDeptCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FGetDeptCommand.Text := 'TServerMethods.GetDept';
    FGetDeptCommand.Prepare;
  end;
  FGetDeptCommand.ExecuteUpdate;
  Result := TCustomSQLDataSet.Create(nil, FGetDeptCommand.Parameters[0].Value.GetDBXReader(False), True);
  Result.Open;
  if FInstanceOwner then
    FGetDeptCommand.FreeOnExecute(Result);
end;

function TServerMethodsClient.GetEmp(DeptNo: Integer): TDataSet;
begin
  if FGetEmpCommand = nil then
  begin
    FGetEmpCommand := FDBXConnection.CreateCommand;
    FGetEmpCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FGetEmpCommand.Text := 'TServerMethods.GetEmp';
    FGetEmpCommand.Prepare;
  end;
  FGetEmpCommand.Parameters[0].Value.SetInt32(DeptNo);
  FGetEmpCommand.ExecuteUpdate;
  Result := TCustomSQLDataSet.Create(nil, FGetEmpCommand.Parameters[1].Value.GetDBXReader(False), True);
  Result.Open;
  if FInstanceOwner then
    FGetEmpCommand.FreeOnExecute(Result);
end;

function TServerMethodsClient.CheckUser(username: string; passwd: string): Boolean;
begin
  if FCheckUserCommand = nil then
  begin
    FCheckUserCommand := FDBXConnection.CreateCommand;
    FCheckUserCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FCheckUserCommand.Text := 'TServerMethods.CheckUser';
    FCheckUserCommand.Prepare;
  end;
  FCheckUserCommand.Parameters[0].Value.SetWideString(username);
  FCheckUserCommand.Parameters[1].Value.SetWideString(passwd);
  FCheckUserCommand.ExecuteUpdate;
  Result := FCheckUserCommand.Parameters[2].Value.GetBoolean;
end;

procedure TServerMethodsClient.DeptModify(DeptNo: Integer; DName: string; Loc: string; op_type: Integer);
begin
  if FDeptModifyCommand = nil then
  begin
    FDeptModifyCommand := FDBXConnection.CreateCommand;
    FDeptModifyCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FDeptModifyCommand.Text := 'TServerMethods.DeptModify';
    FDeptModifyCommand.Prepare;
  end;
  FDeptModifyCommand.Parameters[0].Value.SetInt32(DeptNo);
  FDeptModifyCommand.Parameters[1].Value.SetWideString(DName);
  FDeptModifyCommand.Parameters[2].Value.SetWideString(Loc);
  FDeptModifyCommand.Parameters[3].Value.SetInt32(op_type);
  FDeptModifyCommand.ExecuteUpdate;
end;

procedure TServerMethodsClient.EmpModify(Empno: Integer; EName: string; Job: string; Mgr: Integer; HireDate: TDateTime; Sal: Double; Comm: Double; Deptno: Integer; op_type: Integer);
begin
  if FEmpModifyCommand = nil then
  begin
    FEmpModifyCommand := FDBXConnection.CreateCommand;
    FEmpModifyCommand.CommandType := TDBXCommandTypes.DSServerMethod;
    FEmpModifyCommand.Text := 'TServerMethods.EmpModify';
    FEmpModifyCommand.Prepare;
  end;
  FEmpModifyCommand.Parameters[0].Value.SetInt32(Empno);
  FEmpModifyCommand.Parameters[1].Value.SetWideString(EName);
  FEmpModifyCommand.Parameters[2].Value.SetWideString(Job);
  FEmpModifyCommand.Parameters[3].Value.SetInt32(Mgr);
  FEmpModifyCommand.Parameters[4].Value.AsDateTime := HireDate;
  FEmpModifyCommand.Parameters[5].Value.SetDouble(Sal);
  FEmpModifyCommand.Parameters[6].Value.SetDouble(Comm);
  FEmpModifyCommand.Parameters[7].Value.SetInt32(Deptno);
  FEmpModifyCommand.Parameters[8].Value.SetInt32(op_type);
  FEmpModifyCommand.ExecuteUpdate;
end;


constructor TServerMethodsClient.Create(ADBXConnection: TDBXConnection);
begin
  inherited Create(ADBXConnection);
end;


constructor TServerMethodsClient.Create(ADBXConnection: TDBXConnection; AInstanceOwner: Boolean);
begin
  inherited Create(ADBXConnection, AInstanceOwner);
end;


destructor TServerMethodsClient.Destroy;
begin
  FreeAndNil(FGetDeptCommand);
  FreeAndNil(FGetEmpCommand);
  FreeAndNil(FCheckUserCommand);
  FreeAndNil(FDeptModifyCommand);
  FreeAndNil(FEmpModifyCommand);
  inherited;
end;

end.

