unit uModifyEmp;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, StdCtrls,
  Controls, ExtCtrls, Classes;

type
  TfModifyEmp = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edEmpno: TEdit;
    edEName: TEdit;
    edJob: TEdit;
    Panel2: TPanel;
    btOK: TButton;
    btCancel: TButton;
    Label4: TLabel;
    edMgr: TEdit;
    Label5: TLabel;
    edHireDate: TEdit;
    Label6: TLabel;
    edSal: TEdit;
    Label7: TLabel;
    edComm: TEdit;
    Label8: TLabel;
  private
    { Private declarations }
    function GetEmpno: integer;
    procedure SetEmpno(Value: integer);
    function GetEname: string;
    procedure SetEname(Value: string);
    function GetComm: real;
    function GetHiredate: TDateTime;
    function GetJob: string;
    function GetMgr: integer;
    function GetSal: real;
    procedure SetComm(Value: real);
    procedure SetHiredate(Value: TDateTime);
    procedure SetJob(Value: string);
    procedure SetMgr(Value: integer);
    procedure SetSal(Value: real);
  public
    { Public declarations }
    property EmpNo: integer read GetEmpno write SetEmpno;
    property EName: string read GetEname write SetEname;
    property Job: string read GetJob write SetJob;
    property Mgr: integer read GetMgr write SetMgr;
    property Hiredate: TDateTime read GetHiredate write SetHiredate;
    property Sal: real read GetSal write SetSal;
    property Comm: real read GetComm write SetComm;
  end;

implementation

{$R *.dfm}

{ TfModifyEmp }

function TfModifyEmp.GetComm: real;
begin
  Result := 0;
  if edComm.Text <> '' then
    Result := StrToFloat(edComm.Text);
end;

function TfModifyEmp.GetEmpno: integer;
begin
  Result := -1;
  if edEmpno.Text <> '' then
    Result := StrToInt(edEmpno.Text);
end;

function TfModifyEmp.GetEname: string;
begin
  Result := edEName.Text;
end;

function TfModifyEmp.GetHiredate: TDateTime;
begin
  Result := now;
  if edHireDate.Text <> '' then
    Result := StrToDateTime(edHireDate.Text);
end;

function TfModifyEmp.GetJob: string;
begin
  Result := edJob.Text;
end;

function TfModifyEmp.GetMgr: integer;
begin
  Result := 0;
  if edMgr.Text <> '' then
    Result := StrToInt(edMgr.Text);
end;

function TfModifyEmp.GetSal: real;
begin
  Result := 0;
  if edSal.Text <> '' then
    Result := StrToFloat(edSal.Text);
end;

procedure TfModifyEmp.SetComm(Value: real);
var
  dn: Double;
begin
  if not TryStrToFloat(edComm.Text, dn) then edComm.Text := '0';

  if Value <> StrToInt(edComm.Text) then
      edEmpno.Text := FloatToStr(Value);
end;

procedure TfModifyEmp.SetEmpno(Value: integer);
var
  dn: Integer;
begin
  if not TryStrToInt(edEmpno.Text, dn) then edEmpno.Text := '0';

  if Value <> StrToInt(edEmpno.Text) then
  begin
    if Value <> -1 then
    begin
      edEmpno.Text := IntToStr(Value);
      edEmpno.ReadOnly := true;
    end;
  end;
end;

procedure TfModifyEmp.SetEname(Value: string);
begin
  if Value <> edEName.Text then
  begin
    edEName.Text := Value;
  end;
end;

procedure TfModifyEmp.SetHiredate(Value: TDateTime);
var
  dt: TDateTime;
begin
  if not TryStrToDateTime(edHireDate.Text, dt) then edHireDate.Text := DateTimeToStr(now);

  if Value <> StrToDateTime(edHireDate.Text) then
    edHireDate.Text := DateTimeToStr(Value);
end;

procedure TfModifyEmp.SetJob(Value: string);
begin
  if Value <> edJob.Text then
    edJob.Text := Value;
end;

procedure TfModifyEmp.SetMgr(Value: integer);
var
  dn: Integer;
begin
  if not TryStrToInt(edMgr.Text, dn) then edMgr.Text := '0';

  if Value <> StrToInt(edMgr.Text) then
      edEmpno.Text := IntToStr(Value);
end;

procedure TfModifyEmp.SetSal(Value: real);
var
  dn: Double;
begin
  if not TryStrToFloat(edComm.Text, dn) then edComm.Text := '0';

  if Value <> StrToInt(edComm.Text) then
      edSal.Text := FloatToStr(Value);
end;

end.
