unit uSerevr;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, uServerContainer, StdCtrls, Controls, Classes;

type

  TfMainServer = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edTCPIPPort: TEdit;
    Label3: TLabel;
    edHTTPPort: TEdit;
    GroupBox2: TGroupBox;
    cbPC1: TCheckBox;
    cbRSA: TCheckBox;
    cbZlib: TCheckBox;
    btStart: TButton;
    edPC1Key: TEdit;
    GroupBox3: TGroupBox;
    mStatus: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure btStartClick(Sender: TObject);
  private
    { Private declarations }
    procedure FilterCheckBoxClick(Sender: TObject);
  public
    { Public declarations }
  end;

var
  fMainServer: TfMainServer;

implementation

{$R *.dfm}

procedure TfMainServer.btStartClick(Sender: TObject);
begin
  if not ServerContainer.DSServer.Started then
  begin
    ServerContainer.DSTCPServerTransport.Port := StrToInt(edTCPIPPort.Text);
    ServerContainer.DSHTTPService.DSPort      := StrToInt(edHTTPPort.Text);
    ServerContainer.DSServer.Start;
    mStatus.Lines.Add(Format('%s: TCP/IP Started',[TimeToStr(now)]));
    ServerContainer.DSHTTPService.Start;
    mStatus.Lines.Add(Format('%s: HTTP Started',[TimeToStr(now)]));
    btStart.Caption := 'Stop';
  end
  else
  begin
    ServerContainer.DSHTTPService.Stop;
    mStatus.Lines.Add(Format('%s: HTTP Stoped',[TimeToStr(now)]));
    ServerContainer.DSServer.Stop;
    mStatus.Lines.Add(Format('%s: TCP/IP Stoped',[TimeToStr(now)]));
    btStart.Caption := 'Start';
  end;
end;

procedure TfMainServer.FilterCheckBoxClick(Sender: TObject);
begin
  if not (Sender is TCheckBox) then
    exit;
  if TCheckBox(Sender).Checked then
  begin
    if not ServerContainer.AddFilter(ServerContainer.DSTCPServerTransport, TCheckBox(Sender).Caption, edPC1Key.Text) then
      MessageDlg(format('Cannot Add %s Filter For TCP/IP, Or Filter Already Exists.', [TCheckBox(Sender).Caption]), mtError, [mbOK], 0);
    if not ServerContainer.AddFilter(ServerContainer.DSHTTPService, TCheckBox(Sender).Caption, edPC1Key.Text) then
      MessageDlg(format('Cannot Add %s Filter For HTTP, Or Filter Already Exists.', [TCheckBox(Sender).Caption]), mtError, [mbOK], 0);
  end
  else
  begin
    ServerContainer.RemoveFilter(ServerContainer.DSTCPServerTransport, TCheckBox(Sender).Caption);
    ServerContainer.RemoveFilter(ServerContainer.DSHTTPService, TCheckBox(Sender).Caption);
  end;
end;

procedure TfMainServer.FormCreate(Sender: TObject);
begin
  cbPC1.OnClick  :=  FilterCheckBoxClick;
  cbRSA.OnClick  :=  FilterCheckBoxClick;
  cbZlib.OnClick :=  FilterCheckBoxClick;
end;

end.

